Imports System.Math

''' <summary>
''' Base class for Drive actors.
''' 
''' UsarSim knows several kinds of steering models like
''' skid-steering, Ackerman steering and differential drive.
''' 
''' </summary>
''' <remarks></remarks>
Public MustInherit Class DriveActor
    Inherits Actor

    Public Shared ReadOnly ACTORTYPE_DRIVE As String = "Drive"

    Public Sub New()
        MyBase.New(ACTORTYPE_DRIVE, ACTORTYPE_DRIVE)
    End Sub

    Public MustOverride Sub Drive(ByVal speed As Single)
    Public MustOverride Sub DifferentialDrive(ByVal speed As Single, ByVal left As Single)
    Public MustOverride Sub Turn(ByVal left As Single)
    Public MustOverride Sub CameraPanTilt(ByVal up As Double)
    Public MustOverride Sub ToggleHeadLight()

End Class
