Public Class GPSSensor
    Inherits SingleStateSensor(Of GPSData)

    Public Shared ReadOnly SENSORTYPE_GPS As String = "GPS"

        'From GPSSensor.uc
        Private ZeroZeroLocationLatDeg As Integer = 39
        Private ZeroZeroLocationLonDeg As Integer = 77 'NIST coordinates

        Private ZeroZeroLocationLatMin As Double = 8.0273
        Private ZeroZeroLocationLonMin As Double = 12.998 'NIST coordinates

        Private ScaleLatitudeDeg As Integer = 111200 ' 111 km per degree
        Private ScaleLongitudeDeg As Integer = 71670 '  72 km per degree

        Private ScaleLatitudeMin As Double = ScaleLatitudeDeg / 60
        Private ScaleLongitudeMin As Double = ScaleLongitudeDeg / 60


    Public Sub New()
        MyBase.New(New GPSData, SENSORTYPE_GPS, Sensor.MATCH_ANYNAME)
    End Sub

    Protected Overrides Sub ProcessMessage(ByVal msgtype As MessageType, ByVal msg As System.Collections.Specialized.StringDictionary)
        MyBase.ProcessMessage(msgtype, msg)

        If msgtype = MessageType.Sensor Then
            Me.CurrentData.Load(msg)
            Me.Agent.NotifySensorUpdate(Me)
        End If

    End Sub


    Private _X As Double = 0.0
    Public Property X() As Double
        Get
            Return _X
        End Get
        Set(ByVal value As Double)
            _X = value
        End Set
    End Property

    Private _Y As Double = 0.0
    Public Property Y() As Double
        Get
            Return _Y
        End Get
        Set(ByVal value As Double)
            _Y = value
        End Set

    End Property

    Private _Acquired As Boolean = False
    Public Property Acquired() As Boolean
        Get
            Return _Acquired
        End Get
        Set(ByVal value As Boolean)
            _Acquired = value
        End Set
    End Property




End Class
