Imports UvARescue.Math

Public Class OdometrySensor
    Inherits SingleStateSensor(Of OdometryData)

    Public Shared ReadOnly SENSORTYPE_ODOMETRY As String = "Odometry"

    Public Sub New()
        MyBase.New(New OdometryData, SENSORTYPE_ODOMETRY, Sensor.MATCH_ANYNAME)
    End Sub

    Public Sub Reset(ByVal x As Double, ByVal y As Double, ByVal theta As Double)
        Me.CurrentData.ResetOffsets(x, y, theta)
    End Sub

    Protected Overrides Sub ProcessMessage(ByVal msgtype As MessageType, ByVal msg As System.Collections.Specialized.StringDictionary)
        MyBase.ProcessMessage(msgtype, msg)

        If msgtype = MessageType.Sensor Then
            Me.CurrentData.Load(msg)
            Me.Agent.NotifySensorUpdate(Me)
        End If

    End Sub

End Class
