Imports UvARescue.Math

Public Class MatchResult

    Private _RawOdometry As Pose2D 'original odometry from sensor / log file)
    Private _EstimatedOdometry As Pose2D 'the scanmatcher's odometry estimate
    Private _Covariance As Matrix3 'matching covariance
    Private _Distance As Double 'matching distance

    Private _NumIterations As Integer
    Private _NumCorrespondencies As Integer
    Private _NumMilliseconds As Integer

    Private _Converged As Boolean

    Public Sub New(ByVal rawOdometry As Pose2D, ByVal estimatedOdometry As Pose2D, ByVal covariance As Matrix3, ByVal distance As Double, ByVal numIterations As Integer, ByVal numCorrespondencies As Integer, ByVal numMilliseconds As Integer, ByVal converged As Boolean)
        Me._RawOdometry = rawOdometry
        Me._EstimatedOdometry = estimatedOdometry
        Me._Covariance = covariance
        Me._Distance = distance
        Me._NumIterations = numIterations
        Me._NumCorrespondencies = numCorrespondencies
        Me._NumMilliseconds = numMilliseconds
        Me._Converged = converged
    End Sub


    Public ReadOnly Property RawOdometry() As Pose2D
        Get
            Return Me._RawOdometry
        End Get
    End Property

    Public ReadOnly Property EstimatedOdometry() As Pose2D
        Get
            Return Me._EstimatedOdometry
        End Get
    End Property

    Public ReadOnly Property Covariance() As Matrix3
        Get
            Return Me._Covariance
        End Get
    End Property

    Public ReadOnly Property Distance() As Double
        Get
            Return Me._Distance
        End Get
    End Property

    Public ReadOnly Property NumIterations() As Integer
        Get
            Return Me._NumIterations
        End Get
    End Property

    Public ReadOnly Property NumCorrespondencies() As Integer
        Get
            Return Me._NumCorrespondencies
        End Get
    End Property

    Public ReadOnly Property NumMilliseconds() As Integer
        Get
            Return Me._NumMilliseconds
        End Get
    End Property

    Public ReadOnly Property Converged() As Boolean
        Get
            Return Me._Converged
        End Get
    End Property

End Class
