
Imports System.Windows.Forms


Public Class AgentPatchController
    Inherits UserControl

    Friend WithEvents tbPatches As System.Windows.Forms.TrackBar
    Friend WithEvents lblPatchTotal As System.Windows.Forms.Label
    Friend WithEvents lblName As System.Windows.Forms.Label

    Private _SaveMapDialog As SaveMapDialog
    Friend WithEvents btnLeft As System.Windows.Forms.Button
    Friend WithEvents btnRight As System.Windows.Forms.Button
    Private _Name As String

#Region " Constructor / Destructor "

    Public Sub New(ByVal savemapdialog As SaveMapDialog, ByVal name As String, ByVal patchTotal As Integer)

        Me.InitializeComponent()

        Me._Name = name
        Me._SaveMapDialog = savemapdialog
        Me.lblName.Text = name
        Me.lblPatchTotal.Text = patchTotal.ToString
        Me.tbPatches.Maximum = patchTotal
        Me.tbPatches.Value = patchTotal

    End Sub

#End Region

#Region " Actions "
    Private Sub tbPatches_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbPatches.Scroll
        Me.lblPatchTotal.Text = Me.tbPatches.Value.ToString
    End Sub

    Private Sub tbPatches_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tbPatches.MouseUp
        Me._SaveMapDialog.SetPatchTotal(Me._Name, Me.tbPatches.Value)
        Me._SaveMapDialog.RedrawMap()
    End Sub

    Private Sub btnLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLeft.Click
        If Me.tbPatches.Value > 0 Then
            Me.tbPatches.Value -= 1
            Me.lblPatchTotal.Text = Me.tbPatches.Value.ToString
            Me._SaveMapDialog.SetPatchTotal(Me._Name, Me.tbPatches.Value)
            Me._SaveMapDialog.RedrawMap()
        End If
    End Sub

    Private Sub btnRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRight.Click
        If Me.tbPatches.Value < Me.tbPatches.Maximum Then
            Me.tbPatches.Value += 1
            Me.lblPatchTotal.Text = Me.tbPatches.Value.ToString
            Me._SaveMapDialog.SetPatchTotal(Me._Name, Me.tbPatches.Value)
            Me._SaveMapDialog.RedrawMap()
        End If

    End Sub
#End Region

    Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(AgentPatchController))
        Me.lblName = New System.Windows.Forms.Label
        Me.tbPatches = New System.Windows.Forms.TrackBar
        Me.lblPatchTotal = New System.Windows.Forms.Label
        Me.btnRight = New System.Windows.Forms.Button
        Me.btnLeft = New System.Windows.Forms.Button
        CType(Me.tbPatches, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'lblName
        '
        Me.lblName.AutoSize = True
        Me.lblName.Location = New System.Drawing.Point(3, 9)
        Me.lblName.Name = "lblName"
        Me.lblName.Size = New System.Drawing.Size(66, 13)
        Me.lblName.TabIndex = 2
        Me.lblName.Text = "Agent Name"
        '
        'tbPatches
        '
        Me.tbPatches.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tbPatches.Location = New System.Drawing.Point(103, 3)
        Me.tbPatches.Name = "tbPatches"
        Me.tbPatches.Size = New System.Drawing.Size(287, 45)
        Me.tbPatches.TabIndex = 3
        Me.tbPatches.TickFrequency = 10
        '
        'lblPatchTotal
        '
        Me.lblPatchTotal.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblPatchTotal.AutoSize = True
        Me.lblPatchTotal.Location = New System.Drawing.Point(422, 9)
        Me.lblPatchTotal.Name = "lblPatchTotal"
        Me.lblPatchTotal.Size = New System.Drawing.Size(30, 13)
        Me.lblPatchTotal.TabIndex = 13
        Me.lblPatchTotal.Text = "#P   "
        '
        'btnRight
        '
        Me.btnRight.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnRight.AutoSize = True
        Me.btnRight.BackColor = System.Drawing.Color.Transparent
        Me.btnRight.FlatAppearance.BorderSize = 0
        Me.btnRight.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnRight.Image = CType(resources.GetObject("btnRight.Image"), System.Drawing.Image)
        Me.btnRight.Location = New System.Drawing.Point(393, 3)
        Me.btnRight.Margin = New System.Windows.Forms.Padding(0)
        Me.btnRight.Name = "btnRight"
        Me.btnRight.Size = New System.Drawing.Size(26, 24)
        Me.btnRight.TabIndex = 15
        Me.btnRight.UseVisualStyleBackColor = False
        '
        'btnLeft
        '
        Me.btnLeft.AutoSize = True
        Me.btnLeft.BackColor = System.Drawing.Color.Transparent
        Me.btnLeft.FlatAppearance.BorderSize = 0
        Me.btnLeft.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnLeft.Image = Global.UvARescue.Usar.[Lib].My.Resources.Resources.ArrowLeft
        Me.btnLeft.Location = New System.Drawing.Point(72, 3)
        Me.btnLeft.Margin = New System.Windows.Forms.Padding(0)
        Me.btnLeft.Name = "btnLeft"
        Me.btnLeft.Size = New System.Drawing.Size(28, 24)
        Me.btnLeft.TabIndex = 14
        Me.btnLeft.UseVisualStyleBackColor = False
        '
        'AgentPatchController
        '
        Me.Controls.Add(Me.btnRight)
        Me.Controls.Add(Me.btnLeft)
        Me.Controls.Add(Me.lblPatchTotal)
        Me.Controls.Add(Me.tbPatches)
        Me.Controls.Add(Me.lblName)
        Me.Name = "AgentPatchController"
        Me.Size = New System.Drawing.Size(455, 45)
        CType(Me.tbPatches, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

End Class

